<template>
  <div class="bp-intracity">
      <div v-if="isLoading" class="bp-intracity__loader">
        <ObLoader
            :width="10"
            :height="10"
            :duration="2"
            class="bp-intracity__loader-icon"
        />
      </div>

        <ObFunctionalPanel
            :columns="columns"
            :loading="isLoading"
            :show-refresh="false"
            :show-edit="false"
            :show-group="false"
            :show-sort="false"
            :showColumnFilter="false"
            :showAddButton="true"
            addButtonText="Добавить группу опорников"
            @add="onAddGroup"
            @search="onSearch"
        >
        </ObFunctionalPanel>

      <template v-if="groups.length">

        <div class="accordion-header" @click="onAccordionHeaderClick">
          <i class="chevron icon chevron-down" :class="[accOpen ? 'opened' : 'closed']" />
          <div class="accordion-header__item title">
            Наименование
          </div>
          <div class="accordion-header__item date">
            Последние изменения
          </div>
          <div class="accordion-header__item autor">
            Автор
          </div>
        </div>

        <div
            class="baseprices-clustering-groups"
            v-for="(group) in groups"
            :key="group.groupUuid">

          <ObAccordion
              :title="group.title"
              :isEditable="true"
              :isOpen="accOpen"
              @change="changeGroupTitle($event, group)"
          >
            <template v-slot:title-content>
              <div class="accordion-title-item color-blue services-count">
                <template v-if="group.intracityClusterPrices">
                  <span @click.stop="showGroup(group)" title="Смотреть список опорников">Опорники: {{ group.referencePositions.length }}</span>
                </template>
              </div>
              <div class="accordion-title-item date">
                {{ group.updatedAt | date('DD.MM.YYYY, HH:mm') }}
              </div>
              <div class="accordion-title-item autor">
                {{ group.userInfo }}
              </div>
              <i title="Редактировать" class="accordion-title-item edit icon close-sm" @click.stop="onEditGroup(group)" />
              <i title="Удалить" class="accordion-title-item delete-icon icon close-sm" @click.stop="deleteGroup(group)" />
            </template>

            <ObTable
                v-if="group.intracityClusterPrices && group.intracityClusterPrices.length"
                :items="group.intracityClusterPrices"
                :columns="columns"
                :options-save-row="optionsTableSaveItem"
                :footer-disabled="true"
                data-qa="tableDirectionsClusterBP"
            >
              <template slot="typeTs" slot-scope="{ data }">
                <div class="input-wrapper">
                  <ObInlineSelect
                      v-model="data.item.transportTypeUuid"
                      :items="servicesType"
                      label="Выберите"
                      popper-class="resources-dropdown"
                      :inherit-width="false"
                      @input="changeTransportType(data.item, data.item.transportTypeUuid)"
                      data-qa="transportTypeUuidBP"
                      :disabled="!!data.item.groupPriceUuid"
                  />
                  <ObInlineSelect
                      v-if="data.item.transportTypeUuid"
                      v-model="data.item.serviceUuid"
                      :items="getFilteredServicesList(data.item.transportTypeUuid)"
                      displayExpr="title"
                      valueExpr="serviceUuid"
                      groupDisplayExpr="title"
                      groupChildExpr="children"
                      isGrouped
                      label="Выберите"
                      popper-class="resources-dropdown"
                      :inherit-width="false"
                      @input="onSave(data.item, data.item.serviceUuid, group.groupUuid)"
                      data-qa="servicesAutoUuidBP"
                      :disabled="!!data.item.groupPriceUuid"
                  />
                </div>
              </template>

              <template slot="paymentType" slot-scope="{ data }">
                <div class="input-wrapper" v-if="data.item.serviceUuid">
                  <ObRadio
                      label="За час"
                      valueInput="PER_HOUR"
                      v-model="data.item.paymentType"
                      @change="onSave(data.item, data.item.paymentType, group.groupUuid)"
                      data-qa="paymentTypeRadioOneBP"
                  />
                  <ObRadio
                      label="За км"
                      valueInput="PER_KM"
                      v-model="data.item.paymentType"
                      @change="onSave(data.item, data.item.paymentType, group.groupUuid)"
                      data-qa="paymentTypeRadioTwoBP"
                  />
                </div>
              </template>

              <template slot="minPrice" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.serviceUuid"
                    v-model="data.item.minPrice"
                    type="money:2"
                    data-qa="minPriceBP"
                    placeholder="Укажите ставку"
                    :is-valid="data.item.minPrice ? true: false"
                    :mini="true"
                    @change="onSave(data.item, data.item.minPrice, group.groupUuid)"
                />
              </template>

              <template slot="longDistance" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.serviceUuid"
                    v-model="data.item.longDistance"
                    type="number:strict"
                    data-qa="longDistanceBP"
                    :is-valid="data.item.longDistance ? true: false"
                    placeholder="Укажите расстояние"
                    :mini="true"
                    @change="onSave(data.item, data.item.longDistance, group.groupUuid)"
                />
              </template>

              <template slot="longDistanceCoef" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.serviceUuid"
                    v-model="data.item.longDistanceCoef"
                    type="money:2"
                    :isConvertMoney="false"
                    :minValue="0"
                    data-qa="longDistanceCoef"
                    :is-valid="data.item.longDistanceCoef && data.item.longDistanceCoef > 0 && data.item.longDistanceCoef < 10 ? true: false"
                    placeholder="от 0.01 до 9.99"
                    :mini="true"
                    @input="coefChange(data.item, data.item.longDistanceCoef)"
                    @change="onSave(data.item, data.item.longDistanceCoef, group.groupUuid)"
                />
              </template>

              <template slot="perKmPrice" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.paymentType === 'PER_KM' && data.item.serviceUuid"
                    v-model="data.item.perKmPrice.pricePerKm"
                    type="money:2"
                    data-qa="pricePerKmBP"
                    :is-valid="data.item.perKmPrice.pricePerKm ? true: false"
                    placeholder="Укажите ставку за км."
                    :mini="true"
                    @change="onSave(data.item, data.item.perKmPrice.pricePerKm, group.groupUuid)"
                />
              </template>

              <template slot="pricePerHour" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.paymentType === 'PER_HOUR' && data.item.serviceUuid"
                    v-model="data.item.perHourPrice.pricePerHour"
                    type="money:2"
                    data-qa="pricePerHourBP"
                    :is-valid="data.item.perHourPrice.pricePerHour ? true: false"
                    placeholder="Укажите ставку за час"
                    :mini="true"
                    @change="onSave(data.item, data.item.perHourPrice.pricePerHour, group.groupUuid)"
                />
              </template>

              <template slot="avrSpeed" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.paymentType === 'PER_HOUR' && data.item.serviceUuid"
                    v-model="data.item.perHourPrice.avrSpeed"
                    type="number:strict"
                    data-qa="avrSpeedBP"
                    :is-valid="data.item.perHourPrice.avrSpeed ? true: false"
                    placeholder="Укажите среднюю скорость"
                    :mini="true"
                    @change="onSave(data.item, data.item.perHourPrice.avrSpeed, group.groupUuid)"
                />
              </template>

              <template slot="countLoad" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.paymentType === 'PER_HOUR' && data.item.serviceUuid"
                    v-model="data.item.perHourPrice.countLoad"
                    type="number:strict"
                    data-qa="countLoadBP"
                    :is-valid="data.item.perHourPrice.countLoad ? true: false"
                    placeholder="Укажите норматив на погрузку"
                    :mini="true"
                    @change="onSave(data.item, data.item.perHourPrice.countLoad, group.groupUuid)"
                />
              </template>

              <template slot="countUnload" slot-scope="{ data }">
                <ObInput
                    v-if="data.item.paymentType === 'PER_HOUR' && data.item.serviceUuid"
                    v-model="data.item.perHourPrice.countUnload"
                    type="number:strict"
                    data-qa="countUnloadBP"
                    :is-valid="data.item.perHourPrice.countUnload ? true: false"
                    placeholder="Укажите норматив на выгрузку"
                    :mini="true"
                    @change="onSave(data.item, data.item.perHourPrice.countUnload, group.groupUuid)"
                />
              </template>

              <template slot="delete" slot-scope="{ data }">
                <div class="delete-button">
                  <i title="Удалить" class="delete-icon icon close-sm" @click.stop="deletePrice(data.item, group)" />
                </div>
              </template>

            </ObTable>

            <ObButton
                class="addPriceButton"
                label="Добавить тип ТС"
                type="flat"
                icon="plus"
                @click="addPrice(group)"
                data-qa="buttonAddPriceBP"
            />
          </ObAccordion>
        </div>

        <div class="table-footer">
          <ObPagination
              :page="pagination.pageNum"
              :count="pagination.totalElements"
              :page-limit="pagination.pageSize"
              @on-change="clickPage"
          />
        </div>

      </template>
      <template v-else>
        <div class="no-items">
          <p>Здесь вы сможете настраивать кластеризацию для внутригородских перевозок. Для этого добавьте хотя бы одну группу опорников.</p>
          <ObButton
              class="addGroupButton"
              label="Добавить группу опорников"
              type="flat"
              icon="plus"
              @click="onAddGroup"
              data-qa="buttonAddGroupBP"
          />
        </div>
      </template>


      <ObModal
          ref="basePricePointsGroupAdd"
          title="Группа опорников"
          :titleSecond="selectedGroup ? 'Редактирование' : 'Добавление'"
          custom-class="modal-large"
          @closed="closePointsPopup"
      >
        <BasePricePointsGroupForm
            :data-source="selectedGroup"
            @save="onGroupSave"
            @delete="deleteGroup(selectedGroup)"
        />
      </ObModal>

      <ObModal
          ref="deleteGroupModal"
          :title="'Удалить группу?'"
          size="medium"
          :is-show-controls="true"
          ok-text="Удалить"
          @submit="onDeleteGroup"
          data-qa="modalDeleteGroupPointsBP"
      >
        <div v-if="groupForDelete" class="del-direction">{{ groupForDelete.title }}</div>
        <p>Вы точно хотите удалить группу?</p>
      </ObModal>

      <ObModal
          ref="deletePointModal"
          title="Удаление"
          size="medium"
          :is-show-controls="true"
          ok-text="Удалить"
          @submit="onDeletePrice"
          data-qa="modalDeletePointBP"
      >
        Вы точно хотите удалить тип ТС?
      </ObModal>

      <ObModal
          ref="groupViewModal"
          :title="selectedGroup ? 'Группа опорников «'+selectedGroup.title+'»' : ''"
          size="medium"
          :is-show-controls="false"
      >
        <BasePricePointsGroupView
            :group="selectedGroup"
            @close="closeGroupViewModal"
            @edit="onEditGroup"
        />
      </ObModal>

  </div>
</template>

<script>
import api from '@/api';
import ObTable from 'common-components/src/obComponents/obTable';
import ObModal from 'common-components/src/obComponents/obModal';
import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel';
import ObPagination from 'common-components/src/obComponents/obPagination';
import ObButton from 'common-components/src/obComponents/obButton';
import ObRadio from 'common-components/src/obComponents/obRadio';
import ObInput from 'common-components/src/obComponents/obInput';
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect';
import ObLoader from 'common-components/src/obComponents/obLoader';
import ObAccordion from '@/pages/basePricesClustering/components/accordion';
import BasePricePointsGroupForm from './modal/pointsGroup';
import BasePricePointsGroupView from './modal/pointsGroupView';
import columns from './columns';
import {mapActions, mapGetters} from "vuex";
import debounce from "debounce";
import cloneDeep from 'clone-deep';
import _ from 'lodash';

export default {
  name: 'BasePricesIntracity',

  components: {
    ObTable,
    ObRadio,
    ObInput,
    ObInlineSelect,
    ObModal,
    ObFunctionalPanel,
    ObAccordion,
    ObButton,
    ObLoader,
    ObPagination,
    BasePricePointsGroupForm,
    BasePricePointsGroupView,
  },
  data() {
    return {
      columns,
      accOpen: false,
      isLoading: false,
      selectedGroup: null,
      groupForDelete: null,
      priceForDelete: null,
      groups: [],
      usersInfo: [],
      servicesType: [],
      intracityServicesList: [],
      optionsTableSaveItem: {
        onSubmit: async (data, value) => {
          await this.onSave(data, value);
        }
      },
      newIndexCounter: 0,
      dataModel: {
        isNewIndex: undefined,
        transportTypeUuid: undefined,
        serviceUuid: undefined,
        groupPriceUuid: undefined,
        paymentType: 'PER_HOUR',
        longDistance: undefined,
        longDistanceCoef: undefined,
        perHourPrice: {
          pricePerHour: undefined,
          avrSpeed: undefined,
          countLoad: undefined,
          countUnload: undefined,
        },
        perKmPrice: {
          pricePerKm: undefined,
        },
      },
      pagination: {
        pageNum: 0,
        pageSize: 20,
        totalElements: 0
      }
    }
  },
  computed: {
    ...mapGetters({
      services: 'base_prices/services',
      getLocationTitleFromUuid: 'base_prices/getLocationTitleFromUuid',
      getLocationIconFromUuid: 'base_prices/getLocationIconFromUuid',
    }),
  },
  async created() {
    await this.getServices();
    await this.getServicesList();
    await this.getIntracityServicesList();
    await this.loadData();
  },
  methods: {
    ...mapActions({
      getLocations: 'base_prices/getLocations',
      getServices: 'base_prices/getServices',
    }),
    async loadData() {
      try {
        // this.groups = [];
        this.isLoading = true;

        let data = await api.base_prices_intracity.getIntracityClusters( { pageSize: this.pagination.pageSize, pageNum: this.pagination.pageNum });

        if (data.content && data.content.length) {
          let authorUuids = [];
          data.content.filter((e, i ,a) => {
            let res = a.findIndex((t) => t.authorUuid === e.authorUuid) === i;
            if (res) {
              authorUuids.push(data.content[i].authorUuid)
            }
            return res;
          });
          let usersInfo = await api.adminPanel.users.getUsersInfo(authorUuids)
          if (usersInfo.list.length) {
            this.usersInfo = usersInfo.list;
          }

          // форматируем и дополняем данные
          data.content = data.content.map((item) => {

            if(item.intracityClusterPrices && item.intracityClusterPrices.length) {
              item.intracityClusterPrices = item.intracityClusterPrices.reduce((all, price) => {
                let servInfo;
                if (price.servOrServClusterUuid.serviceClusterUuid) {
                  servInfo = this.intracityServicesList.find(serv => serv.serviceClusterUuid === price.servOrServClusterUuid.serviceClusterUuid);
                } else if (price.servOrServClusterUuid.serviceUuid) {
                  servInfo = this.intracityServicesList.find(serv => serv.serviceUuid === price.servOrServClusterUuid.serviceUuid);
                }
                if ( !servInfo ) {
                  return [...all];
                }
                let result = {
                  ...price,
                  transportTypeUuid: servInfo.serviceTypeUuid,
                  serviceUuid: servInfo.serviceUuid,
                }

                if(!price.perHourPrice) {
                  result.perHourPrice = {
                    avrSpeed: null,
                    countLoad: null,
                    countUnload: null,
                    pricePerHour: null,
                  };
                }
                if(!price.perKmPrice) {
                  result.perKmPrice = { pricePerKm: null };
                }

                return [...all, result];
              }, []);
            }

            return {
              ...item,
              userInfo: this.getUserInfo(item.authorUuid),
            }
          });

          this.pagination.pageNum = data.pageNum;
          this.pagination.pageSize = data.pageSize;
          this.pagination.totalElements = data.totalElements;

          this.groups = data.content;

          await this.getLocationsFromData(this.groups);

        } else {
          this.groups = [];
        }
        this.isLoading = false;
      } catch (e) {
        console.error(e);
        this.isLoading = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    onSearch() {
    },
    onAddGroup() {
      this.$refs.basePricePointsGroupAdd.show();
    },
    showGroup(group) {
      this.selectedGroup = group;
      this.$refs.groupViewModal.show();
    },
    closeGroupViewModal() {
      this.$refs.groupViewModal.hide();
    },
    onEditGroup(group) {
      this.selectedGroup = group;
      this.$refs.basePricePointsGroupAdd.show();
    },
    onGroupSave() {
      this.$refs.basePricePointsGroupAdd.hide();
      this.loadData();
    },
    closePointsPopup() {
      this.$refs.basePricePointsGroupAdd.hide();
      this.selectedGroup = null;
    },
    deleteGroup(group) {
      this.groupForDelete = group;
      this.$refs.basePricePointsGroupAdd.hide();
      this.$refs.deleteGroupModal.open();
    },
    async onDeleteGroup() {
      this.$refs.deleteGroupModal.close();
      try {
        await api.base_prices_intracity.deleteIntracityGroup(this.groupForDelete.groupUuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Группа удалена`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления группы'});
      }
      this.deleteGroupModal = null;
    },
    deletePrice(item, group) {
      this.priceForDelete = item;
      this.priceForDelete.group = group;
      this.$refs.deletePointModal.open();
    },
    async onDeletePrice() {
      this.$refs.deletePointModal.close();
      if( this.priceForDelete.isNewIndex !== undefined ){
        let indexForDelete = this.priceForDelete.group.intracityClusterPrices.findIndex((t) => t.isNewIndex === this.priceForDelete.isNewIndex);
        this.priceForDelete.group.intracityClusterPrices.splice(indexForDelete, 1);
        return true;
      } else {
        try {
          await api.base_prices_intracity.deleteIntracityPrice(this.priceForDelete.groupPriceUuid);
          this.$notification({
            type: 'system_notification_success',
            message: `Цена удалена`
          });
          await this.loadData();
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка удаления цены'});
        }
      }
      this.priceForDelete = null;
    },
    async changeGroupTitle(title, group) {
      if (!title || !group) {
        return false;
      }
      try {
        await api.base_prices_intracity.updateIntracityGroup(group.groupUuid, {title: title});
        this.$notification({
          type: 'system_notification_success',
          message: `Группа переименована`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка переименования группы'});
      }
    },
    addPrice(group) {
      let newItem = cloneDeep(this.dataModel);
      newItem.isNewIndex = this.newIndexCounter;
      this.newIndexCounter++;
      group.intracityClusterPrices.push(newItem);
    },
    onAccordionHeaderClick() {
      this.accOpen = !this.accOpen;
    },
    clickPage(page) {
      this.pagination.pageNum = page;
      this.loadData();
    },
    getUserInfo(userUuid) {
      if (this.usersInfo.length) {
        let userData = this.usersInfo.find(user => user.uuid === userUuid);
        if (userData) {
          return userData.firstname + ' ' + userData.lastname;
        }
      }
      return 'Не найден';
    },
    async getLocationsFromData(data) {
      let locations = [];
      if(data.length) {
        data.forEach(group => {
          if(group.referencePositions && group.referencePositions.length) {
            locations = locations.concat(group.referencePositions);
          }
        });
        await this.getLocations(locations);
      }
    },
    onSave: debounce(async function(data, value, groupUuid) {
      if(this.validateData(data)) {

        let params = {
          groupPriceUuid: data.groupPriceUuid,
          groupUuid: groupUuid,
          servOrServClusterUuid: {},
          paymentType: data.paymentType,
          minPrice: data.minPrice,
          longDistance: data.longDistance,
          longDistanceCoef: data.longDistanceCoef,
          perTypePrice: {},
        }

        if( data.paymentType === 'PER_HOUR' ) {
          params.perTypePrice.perHourPrice = data.perHourPrice;
        } else {
          params.perTypePrice.perKmPrice = data.perKmPrice;
        }

        let servInfo = this.intracityServicesList.find(serv => serv.serviceUuid === data.serviceUuid);
        if( servInfo.serviceClusterUuid ) {
          params.servOrServClusterUuid.serviceClusterUuid = servInfo.serviceClusterUuid;
        } else {
          params.servOrServClusterUuid.serviceUuid = data.serviceUuid;
        }

        try {

          if(!params.groupPriceUuid) {

            await api.base_prices_intracity.createIntracityPrice(params)
              .then(() => {
                this.$notification({
                  type: "system_notification_success",
                  message: "Сохранение успешно",
                });
              })
              .finally(() => {
                this.isShowLoader = false;
              });

          } else {

            await api.base_prices_intracity.updateIntracityPrice(data.groupPriceUuid, params)
              .then(() => {
                this.$notification({
                  type: "system_notification_success",
                  message: "Обновление успешно",
                });
              })
              .finally(() => {
                this.isShowLoader = false;
              });

          }

          await this.loadData();

        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка сохранения'
          })
        }

      }
    }, 300),
    validateData( data ) {
      let priceFieldsFilled;
      if( data.paymentType === 'PER_HOUR' ) {
        priceFieldsFilled = ( data.perHourPrice.pricePerHour && data.perHourPrice.avrSpeed && data.perHourPrice.countLoad && data.perHourPrice.countUnload );
      } else {
        priceFieldsFilled = !!data.perKmPrice.pricePerKm;
      }
      if(data.longDistanceCoef <= 0 || data.longDistanceCoef >= 10 ) {
        data.longDistanceCoef = null;
      }
      return ( data.transportTypeUuid && data.serviceUuid && data.paymentType && data.minPrice && data.longDistance && data.longDistanceCoef && priceFieldsFilled );
    },
    async getServicesList() {
      try {
        const res = await api.orders.getTransport('FTL');
        this.servicesType = res;
      } catch (err) {
        console.error(err);
      }
    },
    async getIntracityServicesList() {
      try {
        const res = await api.base_prices_intracity.getIntracityServices();
        let servicesList = res.content.map((item) => {
          let service = this.services[item.serviceUuid] || null;
          if(service) {
            service.groupTitle = item.serviceClusterTitle ? 'Кластера' : service.resourceSubtypeTitle ?? '';
            if(item.serviceClusterTitle) {
              service.title = item.serviceClusterTitle;
            }else {
              service.title = `${service.resourceSubtypeTitle} ${service.resourcePatternParameter}`;
            }
          }
          return { ...service, ...item }
        });
        this.intracityServicesList = servicesList;

      } catch (err) {
        console.error(err);
      }
    },
    getFilteredServicesList( transportTypeUuid ) {
      if( transportTypeUuid ) {
        let filteredList = this.intracityServicesList.filter(item => item.serviceTypeUuid === transportTypeUuid);
        let groups = _.groupBy(filteredList, 'groupTitle');
        if( groups['Кластера'] && groups['Кластера'].length ) {
          groups['Кластера'] = _.uniqBy(groups['Кластера'], function(serv){
            return serv.serviceClusterUuid;
          });
        }
        let listForSelect = Object.keys(groups).map( title => ({ title, children: groups[title] }) );
        return listForSelect;
      } else {
        return [];
      }
    },
    coefChange(item, value) {
      if(value > 9.99) {
        item.longDistanceCoef = 9.99;
      }
    },
    changeTransportType(item, value) {
      if(value) {
        item.serviceUuid = null;
      }
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/mixins';

.bp-intracity{
  position: relative;

  &__loader {
    position: absolute;
    background: $background-white;
    opacity: 0.8;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
    z-index: 999;
    .bp-intracity__loader-icon {
      position: absolute;
      top: calc(50% - 20px);
      left: calc(50% - 20px);
      width: 40px;
      height: 40px;
    }
  }

  &::v-deep {

    .accordion-header {
      position: relative;
      padding: 15px 25px;
      display: flex;
      cursor: pointer;
      align-items: center;

      @media screen and (max-width: 1024px) {
        display: none;
      }

      &__item {
        font-size: 10px;
        line-height: 10px;
        text-transform: uppercase;
        color: $shale-gray;

        &.title {
          flex-grow: 1;
          margin-left: 80px;
        }

        &.date {
          flex-basis: 180px;
        }

        &.autor {
          flex-basis: 240px;
        }
      }

      .chevron {
        position: absolute;
        top: 50%;
        left: 25px;
        transform: translateY(-50%);
        font-size: 23px;
        color: #9DA0AC;
        transition: all 0.2s linear;

        &.closed {
          transform: translateY(-50%) rotate(-90deg);
        }
      }
    }

    .container {
      width: auto;
    }

    .ob-func-panel {
      box-shadow: inset 0px 1px 0px #E5E5E5, inset 0px -1px 0px #E5E5E5;

      &__control-row {
        background-color: transparent;
      }
    }
    .ob-tabs__sliding-line {
      bottom: 0;
    }

    .ob-table-inner {
      z-index: 1;
    }

    td > .td-container {
      min-height: auto;
      padding: 15px 5px;

      & > div{
        width: 100%;
      }
    }

    td:nth-child(5) > .td-container,
    td:nth-child(6) > .td-container,
    td:nth-child(7) > .td-container,
    td:nth-child(8) > .td-container {
      display: flex;
      justify-content: center;
    }

    .ob-accordion__content{
      margin-bottom: 15px;
    }

    .accordion-title-item {
      margin-left: 30px;
    }

    .delete-icon,
    .edit {
      color: #9DA0AC;
      transition: all 0.2s linear;
      cursor: pointer;
      &:hover {
        color: $blue-dust;
      }
    }

    .accordion-title-item.delete-icon{
      margin-right: 1px;
    }
    .accordion-title-item.date {
      flex-basis: 150px;
    }
    .accordion-title-item.autor {
      flex-basis: 150px;
    }
    .accordion-title-item.services-count {
      flex-basis: 150px;
    }

    @media screen and (max-width: 1024px) {
      .accordion-title-item.switcher,
      .accordion-title-item.date,
      .accordion-title-item.autor,
      .accordion-title-item.services-count {
        display: none;
      }
      .delete-icon{
        margin-left: auto;
      }
    }

    .ob-func-panel__control-row span{
      color: $blue-dust;
    }

    .input-wrapper{
      position: relative;
      display: flex;
      align-items: center;
      gap: 15px;

      .ob-inline-select__label-text {
        white-space: nowrap;
        max-width: 250px;
        overflow: hidden;
      }

      & > * {
        flex-basis: 50%;
        flex-grow: 1;
      }
    }

    .table-data .data-row{
      //&:not(:hover){
      //  .ob-input-container .ob-input-wrap{
      //    border-color: transparent;
      //  }
      //}

      //.ob-input-container {
      //  margin-left: -10px;
      //}
    }

  }

}

.baseprices-clustering-directions{
  margin: 10px 0 10px 30px;
}

.service-item {
  display: flex;
  align-items: center;
  justify-content: space-between;
  width: 100%;

  &__title {
    margin-left: 80px;
  }
}

.addPriceButton {
  margin-top: 10px;
  span {
    font-size: 14px;
  }
}


.color-blue {
  color: $blue-dust;
}

.del-direction{
  color: $cobalt-black;
  font-size: 16px;
  font-weight: 700;
  margin-top: 30px;
  margin-bottom: 10px;
}

.no-items{
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 70px 0;
  flex-direction: column;
  text-align: center;

  p{
    color: #9DA0AC;
    font-size: 24px;
    line-height: 29px;
    margin-bottom: 20px;
    width: 630px;
    max-width: 100%;
  }
}

.delete-button{
  text-align: center;
}


</style>